#include <stdio.h>
#include <gtk/gtk.h>
#include <libintl.h>

#include "variables.h"
#include "xgpasm.h"
#include "gestion_x.h"
#include "images.h"

#ifdef HAVE_CONFIG_H
	#include "config.h"
#endif

void set_configuration(Xgpasm *toto,char *nom,char *chaine)
	{
#ifdef DEBUG
	printf("nom recu: %s, chaine recue: %s\n",nom,chaine);
#endif
	if (strcmp(toto->enregistre[0].nom,nom)==0)
		{
		toto->enregistre[0].etat=atoi(chaine);
		switch(atoi(chaine))
			{
			case 1: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->representation->hexa),TRUE); break;
			case 2: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->representation->decimal),TRUE); break;
			case 3: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->representation->octal),TRUE);
			}
		}
	else if (strcmp(toto->enregistre[1].nom,nom)==0)
		{
		toto->enregistre[1].etat=atoi(chaine);
		switch(atoi(chaine))
			{
			case 1: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->niveauDebug->tout),TRUE); break;
			case 2: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->niveauDebug->moyen),TRUE); break;
			case 3: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->niveauDebug->erreurs),TRUE);
			}
		}
	else if (strcmp(toto->enregistre[2].nom,nom)==0)
		{
		toto->enregistre[2].etat=atoi(chaine);
		switch(atoi(chaine))
			{
			case 1: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->formatSortie->INHX8M),TRUE); break;
			case 2: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->formatSortie->INHX8S),TRUE); break;
			case 3: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->formatSortie->INHX32),TRUE);
			}
		}
	else if (strcmp(toto->enregistre[3].nom,nom)==0)
		{
		int nombre;
		nombre=atoi(chaine);
		toto->enregistre[3].etat=nombre;
		if (nombre&1<<0) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->fichiers->erreur),TRUE);
		if (nombre&1<<1) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->fichiers->listing),TRUE);
		if (nombre&1<<2) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->fichiers->objet),TRUE);
//		if (nombre&1<<3) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->fichiers->hex),TRUE);
		}
	else if (strcmp(toto->enregistre[4].nom,nom)==0)
		{
		int nombre;
		nombre=atoi(chaine);
		toto->enregistre[4].etat=nombre;
		if (nombre&1<<0) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->options->casse),TRUE);
		if (nombre&1<<1) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->options->sauve),TRUE);
		}
	else if (strcmp(toto->enregistre[5].nom,nom)==0)
		{
		int nombre;
		nombre=atoi(chaine);
		toto->enregistre[5].etat=nombre;
		if (nombre&1<<0) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->nomSortie->bouton),TRUE);
		}
	else if (strcmp(toto->enregistre[6].nom,nom)==0)
		{
		int nombre;
		nombre=atoi(chaine);
		toto->enregistre[6].etat=nombre;
		if (nombre&1<<0) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->processeur->bouton),TRUE);
		}
	else if (strcmp(toto->enregistreChaine[0].nom,nom)==0)
		{
		toto->enregistreChaine[0].chaine=(char *)malloc((strlen(chaine)+1)*sizeof(char));
		strcpy(toto->enregistreChaine[0].chaine,chaine);
		gtk_entry_set_text(GTK_ENTRY(toto->nomEntree),chaine);
		}
	else if (strcmp(toto->enregistreChaine[1].nom,nom)==0 && GTK_TOGGLE_BUTTON(toto->nomSortie->bouton)->active)
		{
		toto->enregistreChaine[1].chaine=(char *)malloc((strlen(chaine)+1)*sizeof(char));
		strcpy(toto->enregistreChaine[1].chaine,chaine);
		gtk_entry_set_text(GTK_ENTRY(toto->nomSortie->entry),chaine);
		}
	else if (strcmp(toto->enregistreChaine[2].nom,nom)==0 && GTK_TOGGLE_BUTTON(toto->processeur->bouton)->active)
		{
		toto->enregistreChaine[2].chaine=(char *)malloc((strlen(chaine)+1)*sizeof(char));
		strcpy(toto->enregistreChaine[2].chaine,chaine);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(toto->processeur->menuDeroulant)->entry),chaine);
		}
	else if (strcmp(toto->enregistreChaine[3].nom,nom)==0)
		{
		toto->enregistreChaine[3].chaine=(char *)malloc((strlen(chaine)+1)*sizeof(char));
		strcpy(toto->enregistreChaine[3].chaine,chaine);
		gtk_entry_set_text(GTK_ENTRY(toto->optionsSupplementaires),chaine);
		}
	}

void charge_configuration(Xgpasm *toto)
	{
	FILE *fichier;
	char *nom;
	char *chaine;
	if ((fichier=fopen(".xgpasm.data","r"))==NULL)
		{
		printf(_("Can't Open Configuration File. It will be created at exit"));
		return;
		}

	nom=(char *)malloc(31*sizeof(char));
	chaine=(char *)malloc(201*sizeof(char));

	while(!feof(fichier))
		{
		fscanf(fichier,"%s",nom);
		strcat(nom," ");
		fscanf(fichier,"%[^\n]\n",chaine);	/* On scanne tant qu'on ne rencontre pas de retour chariot */
#ifdef DEBUG
		printf("valeur de chaine: %s\n",chaine);
#endif

		set_configuration(toto,nom,chaine+1);	/* +1 pour supprimer l'espace qu'on a scann */
		}

	free(nom);
	free(chaine);
	}

void get_configuration(Xgpasm *toto,Enregistrement *sauve,EnregistrementChaine *sauveChaine)
	{
	if (GTK_TOGGLE_BUTTON(toto->representation->hexa)->active) sauve[0].etat=1;
	else if (GTK_TOGGLE_BUTTON(toto->representation->decimal)->active) sauve[0].etat=2;
	else if (GTK_TOGGLE_BUTTON(toto->representation->octal)->active) sauve[0].etat=3;
	else sauve[0].etat=0;

	if (GTK_TOGGLE_BUTTON(toto->niveauDebug->tout)->active) sauve[1].etat=1;
	else if (GTK_TOGGLE_BUTTON(toto->niveauDebug->moyen)->active) sauve[1].etat=2;
	else if (GTK_TOGGLE_BUTTON(toto->niveauDebug->erreurs)->active) sauve[1].etat=3;
	else sauve[1].etat=0;

	if (GTK_TOGGLE_BUTTON(toto->formatSortie->INHX8M)->active) sauve[2].etat=1;
	else if (GTK_TOGGLE_BUTTON(toto->formatSortie->INHX8S)->active) sauve[2].etat=2;
	else if (GTK_TOGGLE_BUTTON(toto->formatSortie->INHX32)->active) sauve[2].etat=3;
	else sauve[2].etat=0;

	sauve[3].etat=0;
	if (GTK_TOGGLE_BUTTON(toto->fichiers->erreur)->active) sauve[3].etat |= 1<<0;
	if (GTK_TOGGLE_BUTTON(toto->fichiers->listing)->active) sauve[3].etat |= 1<<1;
	if (GTK_TOGGLE_BUTTON(toto->fichiers->objet)->active) sauve[3].etat |= 1<<2;
//	if (GTK_TOGGLE_BUTTON(toto->fichiers->hex)->active) sauve[3].etat |= 1<<3;

	sauve[4].etat=0;
	if (GTK_TOGGLE_BUTTON(toto->options->casse)->active) sauve[4].etat |= 1<<0;
	if (GTK_TOGGLE_BUTTON(toto->options->sauve)->active) sauve[4].etat |= 1<<1;

	sauve[5].etat=0;
	if (GTK_TOGGLE_BUTTON(toto->nomSortie->bouton)->active)
		{
		sauve[5].etat |= 1;
		sauveChaine[1].chaine=gtk_entry_get_text(GTK_ENTRY(toto->nomSortie->entry));
		}
	else
		{
		sauveChaine[1].chaine=(char *)malloc(sizeof(char));
		sauveChaine[1].chaine[0]=0;
		}

	sauve[6].etat=0;
	if (GTK_TOGGLE_BUTTON(toto->processeur->bouton)->active)
		{
		sauve[6].etat |= 1;
		sauveChaine[2].chaine=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(toto->processeur->menuDeroulant)->entry));
		}
	else
		{
		sauveChaine[2].chaine=(char *)malloc(sizeof(char));
		sauveChaine[2].chaine[0]=0;
		}

	sauveChaine[0].chaine=gtk_entry_get_text(GTK_ENTRY(toto->nomEntree));
	sauveChaine[3].chaine=gtk_entry_get_text(GTK_ENTRY(toto->optionsSupplementaires));
	}

void quitte(GtkWidget *sansImportance,Xgpasm *toto)
	{
//mettre ici la sauvegarde des paramtres et les frees

	FILE *fichier;

	if ((fichier=fopen(".xgpasm.data","w"))==NULL) printf(_("Can't Save Configuration"));
	else
		{
		int i=0;
		if (GTK_TOGGLE_BUTTON(toto->options->sauve)->active) get_configuration(toto,toto->enregistre,toto->enregistreChaine);
		else toto->enregistre[4].etat &= ~1<<1;	/* on change uniquement le bit d'enregistrement pour dire qu'il ne faut plus enregistrer, et tout le reste reste comme  l'ouverture du programme */

		while (toto->enregistre[i].nom!=NULL)
			{
			fprintf(fichier,"%s%d\n",toto->enregistre[i].nom,toto->enregistre[i].etat);
			i++;
			}
		i=0;
		while (toto->enregistreChaine[i].nom!=NULL)
			{
			fprintf(fichier,"%s%s\n",toto->enregistreChaine[i].nom,toto->enregistreChaine[i].chaine);
			i++;
			}
		fclose(fichier);
		}

	gtk_main_quit();
	exit(0);
	}

void montre_cache_widget(GtkWidget *bouton,GtkWidget *widget)
	{
	if (GTK_TOGGLE_BUTTON(bouton)->active) gtk_widget_show(widget);
	else gtk_widget_hide(widget);
	}

void cree_fenetre_choix_nom_entree(GtkWidget *sansImportance,Xgpasm *toto)
	{
	toto->lectureFichier=gtk_file_selection_new(_("Choose file to assemble"));
	if(gtk_entry_get_text(GTK_ENTRY(toto->nomEntree))[0]!=0) gtk_file_selection_set_filename(GTK_FILE_SELECTION(toto->lectureFichier),gtk_entry_get_text(GTK_ENTRY(toto->nomEntree)));
	gtk_signal_connect(GTK_OBJECT(toto->lectureFichier),"delete_event",GTK_SIGNAL_FUNC(gtk_widget_destroy),toto->lectureFichier);
	gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(toto->lectureFichier)->cancel_button),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(toto->lectureFichier));
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(toto->lectureFichier)->ok_button),"clicked",GTK_SIGNAL_FUNC(set_nom_entree),toto);
	gtk_widget_show(toto->lectureFichier);
	}

void set_nom_entree(GtkWidget *sansImportance,Xgpasm *toto)
	{
	gtk_widget_hide(toto->lectureFichier);
	gtk_entry_set_text(GTK_ENTRY(toto->nomEntree),gtk_file_selection_get_filename(GTK_FILE_SELECTION(toto->lectureFichier)));
	}

char *get_representation(Representation *representation)
	{
	char *chaine;

	chaine=(char *)malloc(8*sizeof(char));
	strcpy(chaine," -r ");

	if (GTK_TOGGLE_BUTTON(representation->hexa)->active) strcat(chaine,"hex");
	else if (GTK_TOGGLE_BUTTON(representation->decimal)->active) strcat(chaine,"dec");
	else if (GTK_TOGGLE_BUTTON(representation->octal)->active) strcat(chaine,"oct");
	else strcpy(chaine,"");

	return chaine;
	}

char *get_niveau_debug(NiveauDebug *niveauDebug)
	{
	char *chaine;

	chaine=(char *)malloc(5*sizeof(char));
	strcpy(chaine," -w");

	if (GTK_TOGGLE_BUTTON(niveauDebug->tout)->active) strcat(chaine,"0");
	else if (GTK_TOGGLE_BUTTON(niveauDebug->moyen)->active) strcat(chaine,"1");
	else if (GTK_TOGGLE_BUTTON(niveauDebug->erreurs)->active) strcat(chaine,"2");
	else strcpy(chaine,"");

	return chaine;
	}


char *get_format_sortie(FormatSortie *formatSortie)
	{
	char *chaine;

	chaine=(char *)malloc(11*sizeof(char));
	strcpy(chaine," -a ");

	if (GTK_TOGGLE_BUTTON(formatSortie->INHX8M)->active) strcat(chaine,"inhx8m");
	else if (GTK_TOGGLE_BUTTON(formatSortie->INHX8S)->active) strcat(chaine,"inhx8s");
	else if (GTK_TOGGLE_BUTTON(formatSortie->INHX32)->active) strcat(chaine,"inhx32");
	else strcpy(chaine,"");

	return chaine;
	}

char *get_options(Options *options)
	{
	char *chaine;

	chaine=(char *)malloc(21*sizeof(char));
	chaine[0]=0;

	if (GTK_TOGGLE_BUTTON(options->casse)->active) strcat(chaine," -c");

	return chaine;
	}

char *get_nom_sortie(Xgpasm *toto)
	{
	char *chaine;

	chaine=(char *)malloc(55*sizeof(char));

	if (GTK_TOGGLE_BUTTON(toto->nomSortie->bouton)->active && gtk_entry_get_text(GTK_ENTRY(toto->nomSortie->entry))[0]!=0) sprintf(chaine," -o %s",gtk_entry_get_text(GTK_ENTRY(toto->nomSortie->entry)));
	else
		{
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->nomSortie->bouton),FALSE);
		chaine[0]=0;
		}

	return chaine;
	}

char *get_processeur(Processeur *processeur)
	{
	char *chaine;

	chaine=(char *)malloc(21*sizeof(char));
	strcpy(chaine," -p ");

	if (GTK_TOGGLE_BUTTON(processeur->bouton)->active) strcat(chaine,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(processeur->menuDeroulant)->entry)));
	else strcpy(chaine,"");

	return chaine;
	}

char *get_options_supplementaires(GtkWidget *optionsSupplementaires)
	{
	char *chaine;

	chaine=(char *)malloc((strlen(gtk_entry_get_text(GTK_ENTRY(optionsSupplementaires)))+2)*sizeof(char));

	strcpy(chaine," ");
	strcat(chaine,gtk_entry_get_text(GTK_ENTRY(optionsSupplementaires)));

	return chaine;
	}

char *get_nom_entree(GtkWidget *nomEntree)
	{
	char *chaine;

	if (!fopen(gtk_entry_get_text(GTK_ENTRY(nomEntree)),"r"))
		{
		printf("Impossible de trouver le fichier source\n");
		return NULL;
		}

	chaine=(char *)malloc(201*sizeof(char));

	strcpy(chaine," ");
	strcat(chaine,gtk_entry_get_text(GTK_ENTRY(nomEntree)));

	return chaine;
	}

char *get_nom_generique(GtkWidget *entree)
	{
	int i;
	char *chaine;

	chaine=(char *)malloc((strlen(gtk_entry_get_text(GTK_ENTRY(entree)))+1)*sizeof(char));

	strcpy(chaine,gtk_entry_get_text(GTK_ENTRY(entree)));

	i=strlen(chaine);
	while(i>=3 && chaine[i]!='.') i--;
	if (i>3) chaine[i]=0;

	return chaine;
	}


char *redirige_stdout(Xgpasm *toto)
	{
	char *chaine;

	chaine=(char *)malloc(201*sizeof(char));

	strcpy(chaine," > ");
	if (GTK_TOGGLE_BUTTON(toto->nomSortie->bouton)->active)
		{
		int i;
		strcat(chaine,gtk_entry_get_text(GTK_ENTRY(toto->nomSortie->entry)));
		i=strlen(chaine);
		while(i>=0 && chaine[i]!='.') i--;
		if (i>0) chaine[i]=0;
		}
	else
		{
		strcat(chaine,get_nom_generique(toto->nomEntree));
		}
	strcat(chaine,".err");

	return chaine;
	}

void gere_fichiers_crees(Xgpasm *toto)
	{
	char *chaine;

	chaine=(char *)malloc(201*sizeof(char));
	if (GTK_TOGGLE_BUTTON(toto->nomSortie->bouton)->active)
		{
		int i;
		strcpy(chaine,gtk_entry_get_text(GTK_ENTRY(toto->nomSortie->entry)));
		i=strlen(chaine);
		while(i>=0 && chaine[i]!='.') i--;
		if (i>0) chaine[i]=0;
		}
	else
		{
		strcpy(chaine,get_nom_generique(toto->nomEntree));
		}
	strcat(chaine,".err");

	if (!GTK_TOGGLE_BUTTON(toto->fichiers->erreur)->active) remove(chaine);
	strcpy(chaine+strlen(chaine)-3,"lst");
	if (!GTK_TOGGLE_BUTTON(toto->fichiers->listing)->active) remove(chaine);
	strcpy(chaine+strlen(chaine)-3,"cod");
	if (!GTK_TOGGLE_BUTTON(toto->fichiers->objet)->active) remove(chaine);
	strcpy(chaine+strlen(chaine)-3,"hex");
//	printf("on va peut etre enlever: %s\n",chaine);
//	if (!GTK_TOGGLE_BUTTON(toto->fichiers->hex)->active) remove(chaine);

	free(chaine);
	}


void lance_commande(GtkWidget *sansImportance,Xgpasm *toto)
	{
	char *commande;

	commande=(char *)malloc(501*sizeof(char));

	strcpy(commande,NOM_EXE);

	strcat(commande,get_representation(toto->representation));
	strcat(commande,get_niveau_debug(toto->niveauDebug));
	strcat(commande,get_format_sortie(toto->formatSortie));
	strcat(commande,get_options(toto->options));
	strcat(commande,get_nom_sortie(toto));
	strcat(commande,get_processeur(toto->processeur));
	strcat(commande,get_options_supplementaires(toto->optionsSupplementaires));
	if (get_nom_entree(toto->nomEntree)==NULL)
		{
		free(commande);
		return;
		}
	strcat(commande,get_nom_entree(toto->nomEntree));
	strcat(commande,redirige_stdout(toto));
	strcat(commande," 2> ");
	strcat(commande,NOM_FICHIER_ERREUR);

	cree_fenetre_assemblage(toto,toto->assemblage);
	while(gtk_events_pending()) gtk_main_iteration();	//permet de rendre la main momentanment  l'interface graphique (regenere l'affichage)

#ifdef DEBUG
	printf("On va lancer la commande: %s\n",commande);
#endif
	system(commande);

	met_a_jour_fenetre_assemblage(toto->assemblage,redirige_stdout(toto)+3);

	gere_fichiers_crees(toto);

	free(commande);
	}

void met_a_jour_fenetre_assemblage(Assemblage *assemblage,char *nom)
	{
	int nombreErreurs;
	int nombreWarnings;
	int nombreMessages;
	char *chaine,*recupere;
	FILE *fichier;

	gtk_label_set_text(GTK_LABEL(assemblage->informations),_("Assembly Done"));

	gtk_label_get(GTK_LABEL(assemblage->erreursLogicielles),&recupere);
	chaine=(char *)malloc((strlen(recupere)+10)*sizeof(char));
	strcpy(chaine,recupere);
	if ((fichier=fopen("erreur.data","r"))!=NULL)
		{
		fgetc(fichier);
		if(feof(fichier)) strcat(chaine,_("No"));
		else strcat(chaine,_("Yes"));
		fclose(fichier);
		}
	else strcat(chaine,_("Error!"));
	gtk_label_set_text(GTK_LABEL(assemblage->erreursLogicielles),chaine);

	if ((fichier=fopen(nom,"r"))!=NULL)
		{
		nombreErreurs=0;
		nombreWarnings=0;
		nombreMessages=0;
		while(!feof(fichier))
			{
			chaine[0]=0;
			fgets(chaine,8,fichier);	/* on recupere la chaine jusqu'au premier espace, */
			fscanf(fichier,"%*[^\n]\n");	/* puis on lit le reste jusqu'au retour chariot, mais on ne l'enregistre pas. */
			if (strncasecmp(chaine,"Error",5)==0) nombreErreurs++;
			else if (strncasecmp(chaine,"Warning",7)==0) nombreWarnings++;
			else if (strncasecmp(chaine,"Message",7)==0) nombreMessages++;
//			printf("valeur de chaine: %s\n",chaine);
			}
		fclose(fichier);
		}
	else
		{
		nombreErreurs=-1;
		nombreWarnings=-1;
		nombreMessages=-1;
		}
	free(chaine);

	gtk_label_get(GTK_LABEL(assemblage->erreurs),&recupere);
	chaine=(char *)malloc((strlen(recupere)+10)*sizeof(char));
	strcpy(chaine,recupere);
	sprintf(chaine+strlen(recupere),"%d",nombreErreurs);
	gtk_label_set_text(GTK_LABEL(assemblage->erreurs),chaine);
	free(chaine);

	gtk_label_get(GTK_LABEL(assemblage->warnings),&recupere);
	chaine=(char *)malloc((strlen(recupere)+10)*sizeof(char));
	strcpy(chaine,recupere);
	sprintf(chaine+strlen(recupere),"%d",nombreWarnings);
	gtk_label_set_text(GTK_LABEL(assemblage->warnings),chaine);
	free(chaine);

	gtk_label_get(GTK_LABEL(assemblage->messages),&recupere);
	chaine=(char *)malloc((strlen(recupere)+10)*sizeof(char));
	strcpy(chaine,recupere);
	sprintf(chaine+strlen(recupere),"%d",nombreMessages);
	gtk_label_set_text(GTK_LABEL(assemblage->messages),chaine);
	free(chaine);
	}

void affiche_erreur(GtkWidget *sansImportance,char *nom)
	{
	char *chaine;
	chaine=(char *)malloc((strlen(NOM_EDITEUR)+strlen(nom)+6)*sizeof(char));
	sprintf(chaine,"%s \"%s\" &",NOM_EDITEUR,nom);
	system(chaine);
	free(chaine);
	}

void cree_fenetre_assemblage(Xgpasm *toto,Assemblage *assemblage)
	{
	GtkWidget *label;
	GtkWidget *bouton;
	GtkWidget *table,*tableBouton;
	GtkWidget *frame;
	GtkWidget *pixmapWidget;
	GdkPixmap *pixmap;
	GdkBitmap *masque;
	GtkStyle *style;

//creation de la fenetre
	assemblage->fenetre=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(assemblage->fenetre),_("Assemble..."));
	gtk_widget_set_usize(assemblage->fenetre,200,350);
	gtk_container_set_border_width(GTK_CONTAINER(assemblage->fenetre),5);
	gtk_widget_show(assemblage->fenetre);

	style=gtk_widget_get_style(assemblage->fenetre);

//creation de la table incluse dans la fenetre
	table=gtk_table_new(19,11,1);
	gtk_container_add(GTK_CONTAINER(assemblage->fenetre),table);	//on met la table dans la fenetre
	gtk_widget_show(table);	//On montre la table

//frames de dcoration
	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,0,11,0,3);
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_ETCHED_OUT);
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,0,11,4,15);
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
	gtk_widget_show(frame);


	assemblage->informations=gtk_label_new(_("In progress ..."));
	gtk_table_attach_defaults(GTK_TABLE(table),assemblage->informations,1,10,1,2);
	gtk_widget_show(assemblage->informations);

	assemblage->erreursLogicielles=gtk_label_new(_("Error in gpasm: "));
	gtk_table_attach_defaults(GTK_TABLE(table),assemblage->erreursLogicielles,1,10,5,6);
	gtk_widget_show(assemblage->erreursLogicielles);

	bouton=gtk_button_new();
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,1,10,6,7);
	gtk_signal_connect(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(affiche_erreur),NOM_FICHIER_ERREUR);
	gtk_widget_show(bouton);

	tableBouton=gtk_table_new(1,4,1);
	gtk_container_add(GTK_CONTAINER(bouton),tableBouton);	//on met la table dans la fenetre
	gtk_widget_show(tableBouton);

	label=gtk_label_new(_("See"));
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),label,1,3,0,1);
	gtk_widget_show(label);

	pixmap=gdk_pixmap_create_from_xpm_d(assemblage->fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)voirXPM);
	pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),pixmapWidget,0,1,0,1);
	gtk_widget_show(pixmapWidget);

	assemblage->erreurs=gtk_label_new(_("Errors: "));
	gtk_table_attach_defaults(GTK_TABLE(table),assemblage->erreurs,1,10,8,9);
	gtk_widget_show(assemblage->erreurs);

	if (GTK_TOGGLE_BUTTON(toto->fichiers->erreur)->active)
		{
		bouton=gtk_button_new();
		gtk_table_attach_defaults(GTK_TABLE(table),bouton,1,10,9,10);
		gtk_signal_connect(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(affiche_erreur),redirige_stdout(toto)+3);
		gtk_widget_show(bouton);

		tableBouton=gtk_table_new(1,4,1);
		gtk_container_add(GTK_CONTAINER(bouton),tableBouton);	//on met la table dans la fenetre
		gtk_widget_show(tableBouton);

		label=gtk_label_new(_("See"));
		gtk_table_attach_defaults(GTK_TABLE(tableBouton),label,1,3,0,1);
		gtk_widget_show(label);

		pixmap=gdk_pixmap_create_from_xpm_d(assemblage->fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)voirXPM);
		pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
		gtk_table_attach_defaults(GTK_TABLE(tableBouton),pixmapWidget,0,1,0,1);
		gtk_widget_show(pixmapWidget);
		}

	assemblage->warnings=gtk_label_new(_("Warnings: "));
	gtk_table_attach_defaults(GTK_TABLE(table),assemblage->warnings,1,10,11,12);
	gtk_widget_show(assemblage->warnings);

	assemblage->messages=gtk_label_new(_("Messages: "));
	gtk_table_attach_defaults(GTK_TABLE(table),assemblage->messages,1,10,13,14);
	gtk_widget_show(assemblage->messages);

	bouton=gtk_button_new();
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,1,10,16,18);
	gtk_signal_connect_object(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(assemblage->fenetre));
	GTK_WIDGET_SET_FLAGS(bouton,GTK_CAN_DEFAULT);
	gtk_widget_grab_default(bouton);

	tableBouton=gtk_table_new(1,4,1);
	gtk_container_add(GTK_CONTAINER(bouton),tableBouton);	//on met la table dans la fenetre
	gtk_widget_show(tableBouton);

	label=gtk_label_new("Ok");
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),label,1,3,0,1);
	gtk_widget_show(label);

	pixmap=gdk_pixmap_create_from_xpm_d(assemblage->fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)assembleXPM);
	pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),pixmapWidget,0,1,0,1);
	gtk_widget_show(pixmapWidget);

	gtk_widget_show(bouton);
	}

void cree_fenetre_a_propos(void)
	{
	GtkWidget *fenetre;
	GtkWidget *label;
	GtkWidget *bouton;
	GtkWidget *table;
	GtkWidget *frame;

//creation de la fenetre
	fenetre=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(fenetre),_("Assemble..."));
	gtk_widget_set_usize(fenetre,400,400);
	gtk_container_set_border_width(GTK_CONTAINER(fenetre),5);
	gtk_widget_show(fenetre);

//creation de la table incluse dans la fenetre
	table=gtk_table_new(17,11,1);
	gtk_container_add(GTK_CONTAINER(fenetre),table);	//on met la table dans la fenetre
	gtk_widget_show(table);	//On montre la table

//frames de dcoration
	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,0,11,0,3);
	gtk_frame_set_label(GTK_FRAME(frame),_("Graphical Interface Authors:"));
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,0,11,3,12);
	gtk_frame_set_label(GTK_FRAME(frame),_("Main Project Authors:"));
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,0,11,12,17);
	gtk_frame_set_label(GTK_FRAME(frame),_("Information:"));
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
	gtk_widget_show(frame);

	label=gtk_label_new(_("Xavier IZARD: <xizard@enib.fr>,<xizard@chez.com>"));
	gtk_table_attach_defaults(GTK_TABLE(table),label,1,10,1,2);
	gtk_widget_show(label);

	label=gtk_label_new(_("James Bowman <jamesb@??????>\nScott Dattalo <scott@dattalo.com>\nJames Came ron <james.cameron@digital.com>\nStefan Petersen <spe@stacken.kth.se>\nEric Smith <eric@brouhaha.c om>\nAlessandro Zummo <azummo@ita.flashnet.it>\nAndrew Burgess <aab@cichlid.com>\nBruce Stough <sb s@wavefront.com>\nTommy Thorn <thorn@acm.org>\nCharlie Krauter <charlie@mother.com>"));
	gtk_table_attach_defaults(GTK_TABLE(table),label,1,10,4,11);
	gtk_widget_show(label);

	label=gtk_label_new(_("Free software under GNU General Public License\nFor further informations,\n please read COPYING and README files"));
	gtk_table_attach_defaults(GTK_TABLE(table),label,1,10,13,16);
	gtk_widget_show(label);
	}
