#include <gtk/gtk.h>
#include <libintl.h>

#include "variables.h"
#include "xgpasm.h"
#include "gestion_x.h"
#include "images.h"

#ifdef HAVE_CONFIG_H
	#include "config.h"
#endif

int main(int argc,char *argv[])
{
	int i;
	GtkWidget *fenetre;
	GtkWidget *table,*tableBouton;
	GtkWidget *bouton;
	GtkWidget *frame;
	GtkWidget *label;
	GSList *groupeBoutonRadio;
	GList *listePICs=NULL;

	GtkWidget *pixmapWidget;
	GdkPixmap *pixmap;
	GdkBitmap *masque;
	GtkStyle *style;

	Xgpasm *toto;

	Enregistrement enregistrement[] = {
		{"representation ",0},
		{"niveau_debug ",0},
		{"format_sortie ",0},
		{"fichiers ",0x0A},	//un bit par option
		{"options ",0x03},	//un bit par option
		{"specifier_nom_sortie ",0},
		{"specifier_processeur ",0},
		{NULL,0}
		};

	EnregistrementChaine enregistrementChaine[] = {
		{"nom_source ",""},
		{"nom_sortie ",""},
		{"processeur ",""},
		{"options_supplementaires ",""},
		{NULL,NULL}
		};

	textdomain("xgpasm");

	toto=(Xgpasm *)malloc(sizeof(Xgpasm));

	toto->representation=(Representation *)malloc(sizeof(Representation));
	toto->niveauDebug=(NiveauDebug *)malloc(sizeof(NiveauDebug));
	toto->formatSortie=(FormatSortie *)malloc(sizeof(FormatSortie));
	toto->fichiers=(Fichiers *)malloc(sizeof(Fichiers));
	toto->options=(Options *)malloc(sizeof(Options));
	toto->nomSortie=(NomSortie *)malloc(sizeof(NomSortie));
	toto->processeur=(Processeur *)malloc(sizeof(Processeur));
	toto->assemblage=(Assemblage *)malloc(sizeof(Assemblage));

	toto->enregistre=enregistrement;
	toto->enregistreChaine=enregistrementChaine;

	gtk_init(&argc,&argv);

	/* creation de la fenetre */
	fenetre=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(fenetre),_("xgpasm - Graphical assembler for Microchip (TM) PIC (TM) micro-controllers"));
	gtk_widget_set_usize(fenetre,600,400);
	gtk_container_set_border_width(GTK_CONTAINER(fenetre),10);
	gtk_widget_show(fenetre);

	/* creation de la table incluse dans la fenetre */
	table=gtk_table_new(22,26,1);
	gtk_container_add(GTK_CONTAINER(fenetre),table);	//on met la table dans la fenetre
	gtk_widget_show(table);	//On montre la table

	/* creation du logo */
	style=gtk_widget_get_style(fenetre);
	pixmap=gdk_pixmap_create_from_xpm_d(fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)logoXPM);

	pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
	gtk_table_attach_defaults(GTK_TABLE(table),pixmapWidget,21,25,0,3);
	gtk_widget_show(pixmapWidget);

	/* concerne le fichier source */
	label=gtk_label_new(_("Source File Name:"));
	gtk_table_attach_defaults(GTK_TABLE(table),label,1,20,0,1);
	gtk_widget_show(label);

	toto->nomEntree=gtk_entry_new_with_max_length(200);
	gtk_table_attach_defaults(GTK_TABLE(table),toto->nomEntree,1,20,1,2);
	gtk_widget_show(toto->nomEntree);

	bouton=gtk_button_new_with_label(_("Browse..."));
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,1,20,2,3);
	gtk_signal_connect(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(cree_fenetre_choix_nom_entree),toto);
	gtk_widget_show(bouton);

/*
GTK_SHADOW_NONE
GTK_SHADOW_IN	//en arriere plan
GTK_SHADOW_OUT	//en relief
GTK_SHADOW_ETCHED_IN (the default)	//cadre creus
GTK_SHADOW_ETCHED_OUT	//cadre en relief
*/
	/* creation des cases: */
	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,0,26,4,19);
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,1,7,5,11);
	gtk_frame_set_label(GTK_FRAME(frame),_("Radix:"));
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,7,13,5,11);
	gtk_frame_set_label(GTK_FRAME(frame),_("Warning Level:"));
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,13,19,5,11);
	gtk_frame_set_label(GTK_FRAME(frame),_("Hexadecimal Output:"));
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,19,25,5,11);
	gtk_frame_set_label(GTK_FRAME(frame),_("Generated Files:"));
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,1,9,12,16);
	gtk_frame_set_label(GTK_FRAME(frame),_("Options:"));
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,9,17,12,16);
	gtk_frame_set_label(GTK_FRAME(frame),_("Output Name:"));
	gtk_widget_show(frame);

	frame=gtk_frame_new(NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),frame,17,25,12,16);
	gtk_frame_set_label(GTK_FRAME(frame),_("Processor:"));
	gtk_widget_show(frame);


	/* creation des boutons de dfinition de l'extention des nombres */
	bouton=gtk_radio_button_new_with_label(NULL,_("Default"));
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,1,6,6,7);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bouton),TRUE);
	gtk_widget_show(bouton);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->representation->hexa=gtk_radio_button_new_with_label(groupeBoutonRadio,_("Hexadecimal"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->representation->hexa,1,6,7,8);
	gtk_widget_show(toto->representation->hexa);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->representation->decimal=gtk_radio_button_new_with_label(groupeBoutonRadio,_("Decimal"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->representation->decimal,1,6,8,9);
	gtk_widget_show(toto->representation->decimal);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->representation->octal=gtk_radio_button_new_with_label(groupeBoutonRadio,_("Octal"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->representation->octal,1,6,9,10);
	gtk_widget_show(toto->representation->octal);

	/* creation des boutons de choix du niveau de dbugage */
	bouton=gtk_radio_button_new_with_label(NULL,_("Default"));
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,7,12,6,7);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bouton),TRUE);
	gtk_widget_show(bouton);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->niveauDebug->tout=gtk_radio_button_new_with_label(groupeBoutonRadio,_("All"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->niveauDebug->tout,7,12,7,8);
	gtk_widget_show(toto->niveauDebug->tout);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->niveauDebug->moyen=gtk_radio_button_new_with_label(groupeBoutonRadio,_("Not All"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->niveauDebug->moyen,7,12,8,9);
	gtk_widget_show(toto->niveauDebug->moyen);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->niveauDebug->erreurs=gtk_radio_button_new_with_label(groupeBoutonRadio,_("Errors Only"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->niveauDebug->erreurs,7,12,9,10);
	gtk_widget_show(toto->niveauDebug->erreurs);

	/* creation des boutons de choix du type de fichier hex  gnrer */
	bouton=gtk_radio_button_new_with_label(NULL,_("Default"));
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,13,18,6,7);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bouton),TRUE);
	gtk_widget_show(bouton);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->formatSortie->INHX8M=gtk_radio_button_new_with_label(groupeBoutonRadio,"INHX8M");
	gtk_table_attach_defaults(GTK_TABLE(table),toto->formatSortie->INHX8M,13,18,7,8);
	gtk_widget_show(toto->formatSortie->INHX8M);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->formatSortie->INHX8S=gtk_radio_button_new_with_label(groupeBoutonRadio,"INHX8S");
	gtk_table_attach_defaults(GTK_TABLE(table),toto->formatSortie->INHX8S,13,18,8,9);
	gtk_widget_show(toto->formatSortie->INHX8S);

	groupeBoutonRadio=gtk_radio_button_group(GTK_RADIO_BUTTON(bouton));
	toto->formatSortie->INHX32=gtk_radio_button_new_with_label(groupeBoutonRadio,"INHX32");
	gtk_table_attach_defaults(GTK_TABLE(table),toto->formatSortie->INHX32,13,18,9,10);
	gtk_widget_show(toto->formatSortie->INHX32);

	/* creation des boutons de choix des fichiers  gnrer */
	toto->fichiers->erreur=gtk_check_button_new_with_label(_("Error File"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->fichiers->erreur,19,24,6,7);
//	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toto->fichiers->erreur),TRUE);
	gtk_widget_show(toto->fichiers->erreur);

	toto->fichiers->listing=gtk_check_button_new_with_label(_("List File"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->fichiers->listing,19,24,7,8);
	gtk_widget_show(toto->fichiers->listing);

	toto->fichiers->objet=gtk_check_button_new_with_label(_("Object File"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->fichiers->objet,19,24,8,9);
	gtk_widget_show(toto->fichiers->objet);
/*
	toto->fichiers->hex=gtk_check_button_new_with_label(FICHIER_HEX);
	gtk_table_attach_defaults(GTK_TABLE(table),toto->fichiers->hex,19,24,9,10);
	gtk_widget_show(toto->fichiers->hex);
*/
	/* creation des boutons d'options */
	toto->options->casse=gtk_check_button_new_with_label(_("Case Sensitive"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->options->casse,1,8,13,14);
	gtk_widget_show(toto->options->casse);

	toto->options->sauve=gtk_check_button_new_with_label(_("Save On Exit"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->options->sauve,1,8,14,15);
	gtk_widget_show(toto->options->sauve);

	/* Specification du nom de sortie */
	toto->nomSortie->entry=gtk_entry_new_with_max_length(50);
	gtk_table_attach_defaults(GTK_TABLE(table),toto->nomSortie->entry,9,16,14,15);
//	gtk_signal_connect(GTK_OBJECT(toto->nomSortie->entry),"activate",GTK_SIGNAL_FUNC(),toto);
//	gtk_widget_show(toto->nomSortie->entry);

	toto->nomSortie->bouton=gtk_check_button_new_with_label(_("Specify"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->nomSortie->bouton,9,16,13,14);
	gtk_signal_connect(GTK_OBJECT(toto->nomSortie->bouton),"clicked",GTK_SIGNAL_FUNC(montre_cache_widget),toto->nomSortie->entry);
	gtk_widget_show(toto->nomSortie->bouton);


	/* Specification du processeur */
	listePICs=g_list_append(listePICs,"gen");
	listePICs=g_list_append(listePICs,"p12c508");
	listePICs=g_list_append(listePICs,"p12c509");
	listePICs=g_list_append(listePICs,"p16c54");
	listePICs=g_list_append(listePICs,"p16c55");
	listePICs=g_list_append(listePICs,"p16c56");
	listePICs=g_list_append(listePICs,"p16c57");
	listePICs=g_list_append(listePICs,"p16c58");
	listePICs=g_list_append(listePICs,"p16c62");
	listePICs=g_list_append(listePICs,"p16c63");
	listePICs=g_list_append(listePICs,"p16c64");
	listePICs=g_list_append(listePICs,"p16c65");
	listePICs=g_list_append(listePICs,"p16c71");
	listePICs=g_list_append(listePICs,"p16c74");
	listePICs=g_list_append(listePICs,"p16c83");
	listePICs=g_list_append(listePICs,"p16f83");
	listePICs=g_list_append(listePICs,"p16c84");
	listePICs=g_list_append(listePICs,"p16f84");
	listePICs=g_list_append(listePICs,"p16f874");
	listePICs=g_list_append(listePICs,"p16f876");
	listePICs=g_list_append(listePICs,"p16f877");
	listePICs=g_list_append(listePICs,"p18cxx2");
	listePICs=g_list_append(listePICs,"p18c242");
	listePICs=g_list_append(listePICs,"p18c252");
	listePICs=g_list_append(listePICs,"p18c442");
	listePICs=g_list_append(listePICs,"p18c452");
	listePICs=g_list_append(listePICs,"sx18");
	listePICs=g_list_append(listePICs,"sx20");
	listePICs=g_list_append(listePICs,"sx28");

	toto->processeur->menuDeroulant=gtk_combo_new();
	gtk_combo_set_popdown_strings(GTK_COMBO(toto->processeur->menuDeroulant),listePICs);
	gtk_table_attach_defaults(GTK_TABLE(table),toto->processeur->menuDeroulant,17,24,14,15);
//	gtk_widget_show(toto->processeur->menuDeroulant);

	toto->processeur->bouton=gtk_check_button_new_with_label(_("Specify"));
	gtk_table_attach_defaults(GTK_TABLE(table),toto->processeur->bouton,17,24,13,14);
	gtk_signal_connect(GTK_OBJECT(toto->processeur->bouton),"clicked",GTK_SIGNAL_FUNC(montre_cache_widget),toto->processeur->menuDeroulant);
	gtk_widget_show(toto->processeur->bouton);

	/* Options supplmentaires */
	label=gtk_label_new(_("Extra Options:"));
	gtk_table_attach_defaults(GTK_TABLE(table),label,1,8,17,18);
	gtk_widget_show(label);

	toto->optionsSupplementaires=gtk_entry_new_with_max_length(200);
	gtk_table_attach_defaults(GTK_TABLE(table),toto->optionsSupplementaires,8,25,17,18);
	gtk_widget_show(toto->optionsSupplementaires);

/*
Creation des boutons:
Principe: on insere une table dans le bouton, puis on insere une image et un label (texte) dans la table
*/
	bouton=gtk_button_new();
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,2,8,20,22);
	gtk_signal_connect(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(cree_fenetre_a_propos),NULL);
	gtk_widget_show(bouton);

	tableBouton=gtk_table_new(1,4,1);
	gtk_container_add(GTK_CONTAINER(bouton),tableBouton);	//on met la table dans la fenetre
	gtk_widget_show(tableBouton);

	label=gtk_label_new(_("Authors"));
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),label,1,4,0,1);
	gtk_widget_show(label);

	pixmap=gdk_pixmap_create_from_xpm_d(fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)aProposXPM);
	pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),pixmapWidget,0,1,0,1);
	gtk_widget_show(pixmapWidget);

	/* bouton quitter */
	bouton=gtk_button_new();
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,10,16,20,22);
	gtk_signal_connect(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(quitte),toto);
	gtk_widget_show(bouton);

	tableBouton=gtk_table_new(1,4,1);
	gtk_container_add(GTK_CONTAINER(bouton),tableBouton);	//on met la table dans la fenetre
	gtk_widget_show(tableBouton);

	label=gtk_label_new(_("Exit"));
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),label,1,4,0,1);
	gtk_widget_show(label);

	pixmap=gdk_pixmap_create_from_xpm_d(fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)exitXPM);
	pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),pixmapWidget,0,1,0,1);
	gtk_widget_show(pixmapWidget);

	/* bouton assembler */
	bouton=gtk_button_new();
	gtk_table_attach_defaults(GTK_TABLE(table),bouton,18,24,20,22);
	GTK_WIDGET_SET_FLAGS(bouton,GTK_CAN_DEFAULT);
	gtk_widget_grab_default(bouton);
	gtk_signal_connect(GTK_OBJECT(bouton),"clicked",GTK_SIGNAL_FUNC(lance_commande),toto);
	gtk_widget_show(bouton);

	tableBouton=gtk_table_new(1,4,1);
	gtk_container_add(GTK_CONTAINER(bouton),tableBouton);	//on met la table dans la fenetre
	gtk_widget_show(tableBouton);

	label=gtk_label_new(_("Assemble"));
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),label,1,4,0,1);
	gtk_widget_show(label);

	pixmap=gdk_pixmap_create_from_xpm_d(fenetre->window,&masque,&style->bg[GTK_STATE_NORMAL],(char **)assembleXPM);
	pixmapWidget=gtk_pixmap_new(pixmap,masque);	/* widget qui contient l'image */
	gtk_table_attach_defaults(GTK_TABLE(tableBouton),pixmapWidget,0,1,0,1);
	gtk_widget_show(pixmapWidget);


	/* permet que la fenetre se ferme quand on clique sur la croix */
	gtk_signal_connect(GTK_OBJECT(fenetre),"destroy",GTK_SIGNAL_FUNC(quitte),toto);
	charge_configuration(toto);
	gtk_main();
}
